﻿Imports Infragistics.Win
Imports Infragistics.Win.UltraWinDock

Public Class CustomCreationFilter : Implements IUIElementCreationFilter

    Public Event CustomButtonClick(ByVal sender As Object, ByVal e As UIElementEventArgs)
    Private _buttonsWidth As Integer
    Private _dockAreaButtons As Dictionary(Of DockedLocation, Integer)

    Public Sub New(ByVal DockAreaButtons As Dictionary(Of DockedLocation, Integer), ByVal ButtonsWidth As Integer)
        _dockAreaButtons = DockAreaButtons
        _buttonsWidth = ButtonsWidth
    End Sub

    Public Property ButtonsWidth() As Integer
        Get
            Return _buttonsWidth
        End Get
        Set(ByVal value As Integer)
            _buttonsWidth = value
        End Set
    End Property
    Public ReadOnly Property DockAreaButtons() As Dictionary(Of DockedLocation, Integer)
        Get
            Return _dockAreaButtons
        End Get
    End Property


    Public Sub AfterCreateChildElements(ByVal parent As Infragistics.Win.UIElement) Implements Infragistics.Win.IUIElementCreationFilter.AfterCreateChildElements
        If TypeOf parent Is PaneCaptionUIElement Then

            Dim textEl As PaneCaptionTextAreaUIElement = TryCast(parent.GetDescendant(GetType(PaneCaptionTextAreaUIElement)), PaneCaptionTextAreaUIElement)
            Dim el = DirectCast(parent.Parent, PaneUIElement)
            If Not DockAreaButtons.Keys.Contains(el.Pane.DockAreaPane.DockedLocation) Then
                Return
            End If

            Dim CaptionButtons As List(Of UIElement) = parent.ChildElements.Where(Function(x) TypeOf x Is PaneCaptionButtonUIElement Or TypeOf x Is ButtonUIElement).ToList()
            For i As Integer = 0 To DockAreaButtons(el.Pane.DockAreaPane.DockedLocation) - 1
                If CaptionButtons.Where(Function(x) TypeOf x Is ButtonUIElement).Count < DockAreaButtons(el.Pane.DockAreaPane.DockedLocation) Then
                    Dim button As New ButtonUIElement(parent)

                    If CaptionButtons.Count > 0 Then
                        'rectangle if there are other pane buttons
                        button.Rect = New Rectangle(CaptionButtons.Last().Rect.X - ButtonsWidth + 1, CaptionButtons.Last().Rect.Y, ButtonsWidth, CaptionButtons.Last().Rect.Height)
                    Else
                        'rectangle if there are no other pane buttons
                        button.Rect = New Rectangle(parent.Rect.X + parent.Rect.Width - ButtonsWidth - 1, parent.Rect.Y + 1, ButtonsWidth, parent.Rect.Height)
                    End If
                    parent.ChildElements.Add(button)
                    AddHandler button.ElementClick, AddressOf OnCustomButtonClick

                    If textEl IsNot Nothing Then
                        textEl.Rect = New Rectangle(textEl.Rect.Location, New Size(textEl.Rect.Width - button.Rect.Width, textEl.Rect.Height))
                    End If
                    CaptionButtons.Add(button)
                    button.Text = "Button " + (i + 1).ToString()
                End If
            Next
        End If
    End Sub

    Private Sub OnCustomButtonClick(ByVal sender As Object, ByVal e As UIElementEventArgs)
        RaiseEvent CustomButtonClick(sender, e)
    End Sub

    Public Function BeforeCreateChildElements(ByVal parent As Infragistics.Win.UIElement) As Boolean Implements Infragistics.Win.IUIElementCreationFilter.BeforeCreateChildElements
        Return False
    End Function
End Class
