﻿Imports Infragistics.Win
Imports Infragistics.Win.UltraWinDock

Public Class Form1
    Dim WithEvents filter As CustomCreationFilter

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        Dim panesWithButtons As New Dictionary(Of DockedLocation, Integer)
        panesWithButtons.Add(DockedLocation.DockedLeft, 2)
        panesWithButtons.Add(DockedLocation.DockedRight, 1)
        filter = New CustomCreationFilter(panesWithButtons, 90)
        UltraDockManager1.CreationFilter = filter
        UltraDockManager1.DefaultPaneSettings.CaptionAppearance.FontData.SizeInPoints = 10
        UltraDockManager1.ShowCloseButton = False
        UltraDockManager1.ShowPinButton = False
    End Sub

    Private Sub filter_OnCustomButtonClickHandler(ByVal sender As Object, ByVal e As UIElementEventArgs) Handles filter.CustomButtonClick

        Dim button As ButtonUIElement = DirectCast(e.Element, ButtonUIElement)
        Dim pane = DirectCast(button.Parent.Parent, PaneUIElement)

        MessageBox.Show(button.Text + " from " + pane.Pane.DockAreaPane.DockedLocation.ToString() + " area clicked")
    End Sub

    Private Sub UltraButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UltraButton1.Click
        Dim tempWidth As Integer
        If (Integer.TryParse(UltraTextEditor1.Text, tempWidth) AndAlso tempWidth > 0) Then
            filter.ButtonsWidth = tempWidth
        End If

        If (Not String.IsNullOrEmpty(UltraComboEditor1.Text) AndAlso Not String.IsNullOrEmpty(UltraComboEditor2.Text)) Then
            If (filter.DockAreaButtons.Keys.Contains(getDock())) Then
                filter.DockAreaButtons.Remove(getDock())
            End If
            If (Integer.Parse(UltraComboEditor2.Text) > 0) Then
                filter.DockAreaButtons.Add(getDock(), Integer.Parse(UltraComboEditor2.Text))
            End If
        End If
        'used to cause the panes to redraw
        For Each pane As DockableControlPane In UltraDockManager1.ControlPanes
            pane.Activate()
        Next
        'returns the focus to the button
        UltraButton1.Select()
    End Sub

    Private Function getDock() As DockedLocation
        Select Case UltraComboEditor1.Text
            Case "Left"
                Return DockedLocation.DockedLeft
                Exit Select
            Case "Right"
                Return DockedLocation.DockedRight
                Exit Select
            Case "Top"
                Return DockedLocation.DockedTop
                Exit Select
            Case "Bottom"
                Return DockedLocation.DockedBottom
                Exit Select
            Case Else
                Exit Select
        End Select
    End Function

End Class
